SystemOrganization addCategory: #'WS-Sound-Interface'!
SystemOrganization addCategory: #'WS-Sound-Primitives'!

!Morph class methodsFor: '*WS-Sound-Interface' stamp: 'kfr 5/17/2011 17:08'!
additionsToViewerCategoryColor
	"Answer viewer additions for the 'color' category"

	^#(
		color 
		(
			(slot color 'The color of the object' Color readWrite Player getColor  Player  setColor:)
			(slot red 	'Red value of my color from 0 to 100' Number	 readWrite Player getRed Player setRed:)
			(slot green 	'Green value of my color from 0 to 100' Number	 readWrite Player getGreen Player setGreen:)
			(slot blue 	'Blue value of my color from 0 to 100' Number	 readWrite Player getBlue Player setBlue:)
			(slot alpha 	'Alpha value of my color from 0 to 100' Number	 readWrite Player getAlpha Player setAlpha:)
			(slot hue 	'Hue value of my color from -180 to 180' Number	 readWrite Player getHue Player setHue:)
			(slot saturation 	'Saturation value of my color from 0 to 100' Number	 readWrite Player getSaturation Player setSaturation:)
			(slot brightness 	'Brightness value of my color from 0 to 100' Number	 readWrite Player getBrightness Player setBrightness:)
		)
	)
! !

!Morph class methodsFor: '*WS-Sound-Interface' stamp: 'kfr 7/17/2011 16:00'!
additionsToViewerCategorySound
	"Answer viewer additions for the 'sound' category"

	^#(
		sound 
		(
			(command playSound: 'play sound' Number)
			(command setSound: 'select a sound' Sound)
			(command stopSound 'stop sound')
			(command beep: 'Make the specified sound' Sound)
		)
	)
! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 7/31/2003 21:06'!
dial: dialNumberString 
	self costume dial: dialNumberString! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 12/20/2006 13:32'!
getAllowingChord
	^ self getValueFromCostume: #allowingChord! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 6/1/2007 18:39'!
getCutOffLevel
	^ self getValueFromCostume: #cutOffLevel! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:25'!
getDataColor

	^ costume dataColor
! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 7/31/2003 23:40'!
getDialNumber
	^ self getValueFromCostume: #dialNumber! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:24'!
getDirectModeReadOut

	^ costume directModeReadOut
! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 8/12/2003 17:41'!
getFrequency
	^ self getValueFromCostume: #frequency! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getFrequency1
	^ self getValueFromCostume: #frequency1! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getFrequency2
	^ self getValueFromCostume: #frequency2! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getFrequency3
	^ self getValueFromCostume: #frequency3! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/7/2004 18:15'!
getLevel
	^ self getValueFromCostume: #level! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getLevel1
	^ self getValueFromCostume: #level1! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getLevel2
	^ self getValueFromCostume: #level2! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 7/29/2003 12:30'!
getLevel3
	^ self getValueFromCostume: #level3! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/12/2004 23:31'!
getListening
	| stethoscope |
	stethoscope _ WsWorldStethoscope default.
	^ stethoscope isListening! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 12/31/2006 01:46'!
getPassOver
	^ self getValueFromCostume: #passOver! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 12/31/2006 01:46'!
getPassUnder
	^ self getValueFromCostume: #passUnder! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 1/19/2004 23:48'!
getPitch
	^ self getFrequency! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:27'!
getScrollDelta

	^ costume scrollDelta
! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:24'!
getUpdateInterval
	^ costume updateInterval! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 12/20/2006 13:32'!
setAllowingChord: aBoolean
	self costume renderedMorph allowingChord: aBoolean.
! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 6/1/2007 18:39'!
setCutOffLevel: number 
	self setCostumeSlot: #cutOffLevel: toValue: number! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:25'!
setDataColor: aColor

	costume dataColor: aColor! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/12/2004 23:32'!
setListening: aBoolean 
	| stethoscope |
	stethoscope _ WsWorldStethoscope default.
	aBoolean
		ifTrue: [stethoscope start]
		ifFalse: [stethoscope stop]! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 12/31/2006 01:56'!
setPassOver: number 
	self setCostumeSlot: #passOver: toValue: number! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 12/31/2006 01:56'!
setPassUnder: number 
	self setCostumeSlot: #passUnder: toValue: number! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:27'!
setScrollDelta: aNumber

	^ costume scrollDelta: aNumber

! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'yo 7/16/2008 15:24'!
setUpdateInterval: aNumber

	costume updateInterval: aNumber! !

!Player methodsFor: '*WS-Sound-Interface' stamp: 'ka 9/11/2003 15:58'!
stopSound
	| playingSound |
	playingSound _ self costume
				valueOfProperty: #playingSound
				ifAbsent: [].
	playingSound
		ifNotNil: [playingSound stopGracefully.
			self costume removeProperty: #playingSound]! !

AlignmentMorph subclass: #WsPhonePadMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsPhonePadMorph class methodsFor: 'scripting' stamp: 'ka 7/31/2003 21:06'!
additionsToViewerCategories
	^ #(#(#phonepad #(#(#command #dial: 'Dial a telephone number' #String))) )! !

!WsPhonePadMorph class methodsFor: 'scripting' stamp: 'KR 5/23/2008 01:31'!
defaultNameStemForInstances
	^ 'PhonePad' translatedNoop! !

!WsPhonePadMorph class methodsFor: 'parts bin' stamp: 'tak 7/25/2007 00:13'!
descriptionForPartsBin
	^ self
		partName: 'PhonePad' translatedNoop
		categories: {'Multimedia' translatedNoop}
		documentation: 'A device for dialing by tone.' translatedNoop! !

!WsPhonePadMorph class methodsFor: 'class initialization' stamp: 'ka 3/25/2005 21:43'!
initialize
	self registerInFlapsRegistry! !

!WsPhonePadMorph class methodsFor: 'class initialization' stamp: 'KR 8/12/2007 11:18'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: {#WsPhonePadMorph	.	#authoringPrototype.		'PhonePad' translatedNoop. 'A device for dialing by tone.'}
						forFlapNamed: 'Widgets'.
						cl registerQuad: {#WsPhonePadMorph.	#authoringPrototype.		'PhonePad' translatedNoop. 'A device for dialing by tone.'}
						forFlapNamed: 'PlugIn Supplies'.]! !

!WsPhonePadMorph class methodsFor: 'class initialization' stamp: 'ka 3/25/2005 21:42'!
unload
	"Unload the receiver from global registries"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!WsPhonePadMorph methodsFor: 'initialization' stamp: 'yo 7/9/2007 12:26'!
addButtonRows

	| row |
	row _ AlignmentMorph newRow vResizing: #spaceFill.
	row cellInset: 3.
	row addMorphBack: (self buttonName: '1').
	row addMorphBack: (self buttonName: '2').
	row addMorphBack: (self buttonName: '3').
	row addMorphBack: (self buttonName: 'A').
	self addMorphBack: row.
	row _ AlignmentMorph newRow vResizing: #spaceFill.
	row cellInset: 3.
	row addMorphBack: (self buttonName: '4').
	row addMorphBack: (self buttonName: '5').
	row addMorphBack: (self buttonName: '6').
	row addMorphBack: (self buttonName: 'B').
	self addMorphBack: row.
	row _ AlignmentMorph newRow vResizing: #spaceFill.
	row cellInset: 3.
	row addMorphBack: (self buttonName: '7').
	row addMorphBack: (self buttonName: '8').
	row addMorphBack: (self buttonName: '9').
	row addMorphBack: (self buttonName: 'C').
	self addMorphBack: row.
	row _ AlignmentMorph newRow vResizing: #spaceFill.
	row cellInset: 3.
	row addMorphBack: (self buttonName: '*').
	row addMorphBack: (self buttonName: '0').
	row addMorphBack: (self buttonName: '#').
	row addMorphBack: (self buttonName: 'D').
	self addMorphBack: row.
	^ row fullBounds.
! !

!WsPhonePadMorph methodsFor: 'menu commands' stamp: 'ka 3/25/2005 21:15'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'dial to...' translated action: #dialTo.
! !

!WsPhonePadMorph methodsFor: 'others' stamp: 'sw 9/5/2007 15:26'!
buttonName: aString
	^ SimpleButtonMorph new target: self;
		label: aString font: Preferences standardEToysButtonFont;
		 actionSelector: #dial:;
		 arguments: (Array with: aString);
		hResizing: #spaceFill;
		vResizing: #spaceFill.
		! !

!WsPhonePadMorph methodsFor: 'menu commands' stamp: 'KR 4/30/2008 21:54'!
dialTo
	| dialNumberString |
	dialNumberString _ FillInTheBlank request: 'Phone number?' translated.
	dialNumberString isEmpty
		ifTrue: [^ self].
	self dial: dialNumberString! !

!WsPhonePadMorph methodsFor: 'button commands' stamp: 'ka 7/31/2003 21:05'!
dial: dialNumberString 
	AbstractSound dial: dialNumberString.
	"(Delay forSeconds: 0.2 * dialNumberString size) wait"! !

!WsPhonePadMorph methodsFor: 'initialization' stamp: 'yo 7/9/2007 12:30'!
initialize
	| w h |
	super initialize.
	self layoutPolicy: TableLayout new.
	self listDirection: #topToBottom.
	self vResizing: #spaceFill.
	self cellInset: 3.
	self cellPositioning: #center.
	self listCentering: #justified.
	self wrapCentering: #justified.
	borderWidth _ 2.
	w _ (Preferences standardEToysFont widthOf: $A) * (4 + 4 + 2).
	h _ (Preferences standardEToysFont height) * (4 + 2).
	self addButtonRows.
	self extent: w@h! !

AlignmentMorph subclass: #WsWorldStethoscopeMorph
	instanceVariableNames: 'statusLight model directModeLight biasModeLight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsWorldStethoscopeMorph class methodsFor: 'scripting' stamp: 'yo 7/16/2008 14:44'!
additionsToViewerCategories
	^ # ((sound (
(slot readOut 'the value for the direct input mode.' Number readOnly player getDirectModeReadOut unused unused)
(slot frequency1 'frequency-1 of sound' Number readOnly player getFrequency1 unused unused)
(slot level1 'level-1 of sound' Number readOnly player getLevel1 unused unused)
(slot frequency2 'frequency-2 of sound' Number readOnly player getFrequency2 unused unused)
(slot level2 'level-2 of sound' Number readOnly player getLevel2 unused unused)
(slot frequency3 'frequency-3 of sound' Number readOnly player getFrequency3 unused unused)
(slot level3 'level-3 of sound' Number readOnly player getLevel3 unused unused)
(slot dialNumber 'dial number of sound' String readOnly player getDialNumber unused unused)
(slot soundListening 'whether the stethoscope is listening' Boolean readWrite Player getListening Player setListening:)
(slot passOver 'high pass filter value' Number readWrite player getPassOver player setPassOver:)
(slot passUnder 'low pass filter value' Number readWrite player getPassUnder player setPassUnder:)
(slot cutOffLevel 'cut off level' Number readWrite player getCutOffLevel player setCutOffLevel:)
(slot updateInterval: 'specify how often read the input.' Number readWrite player getUpdateInterval player setUpdateInterval:)
)))
! !

!WsWorldStethoscopeMorph class methodsFor: 'scripting' stamp: 'KR 5/23/2008 01:32'!
defaultNameStemForInstances
	^ 'WorldStethoscope' translatedNoop
! !

!WsWorldStethoscopeMorph class methodsFor: 'parts bin' stamp: 'tak 7/25/2007 00:13'!
descriptionForPartsBin
	^ self
		partName: 'WorldStethoscope' translatedNoop
		categories: {'Multimedia'  translatedNoop}
		documentation: 'A device for analyzing phenomena as sounds' translatedNoop
! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'ka 7/30/2003 01:46'!
example1
	"WsWorldStethoscopeMorph example1"
	self new openInHand! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'ka 7/30/2003 01:46'!
example2
	"WsWorldStethoscopeMorph example2"
	| duration mixedSound |
	duration _ 10.
	mixedSound _ MixedSound new.
	mixedSound
		add: (FMSound new
				setPitch: 440
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 880
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 1760
				dur: duration
				loudness: 0.5).
	mixedSound play.
	^ mixedSound! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'ka 7/31/2003 23:41'!
example3
	"WsWorldStethoscopeMorph example3"
	| duration mixedSound |
	duration _ 10.
	mixedSound _ MixedSound new.
	mixedSound
		add: (FMSound new
				setPitch: 697
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 1209
				dur: duration
				loudness: 0.5).
	mixedSound play.
	^ mixedSound! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'ka 7/31/2003 23:01'!
example4
	"WsWorldStethoscopeMorph example4"
	| duration mixedSound |
	duration _ 10.
	mixedSound _ MixedSound new.
	mixedSound
		add: (FMSound new
				setPitch: 941
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 1633
				dur: duration
				loudness: 0.5).
	mixedSound play.
	^ mixedSound! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'tetha 8/12/2003 19:34'!
example5
	"WsWorldStethoscopeMorph example5"
	| duration mixedSound |
	duration _ 10.
	mixedSound _ MixedSound new.
	mixedSound
		add: (FMSound new
				setPitch: 524
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 588
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 660
				dur: duration
				loudness: 0.5).
	mixedSound play.
	^ mixedSound! !

!WsWorldStethoscopeMorph class methodsFor: 'examples' stamp: 'tetha 8/12/2003 22:20'!
example6
	"WsWorldStethoscopeMorph example6"
	| duration mixedSound |
	duration _ 10.
	mixedSound _ MixedSound new.
	mixedSound
		add: (FMSound new
				setPitch: 524
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 660
				dur: duration
				loudness: 0.5).
	mixedSound
		add: (FMSound new
				setPitch: 784
				dur: duration
				loudness: 0.5).
	mixedSound play.
	^ mixedSound
! !

!WsWorldStethoscopeMorph class methodsFor: 'class initialization' stamp: 'ka 3/25/2005 21:27'!
initialize
	self registerInFlapsRegistry! !

!WsWorldStethoscopeMorph class methodsFor: 'class initialization' stamp: 'KR 8/12/2007 11:19'!
registerInFlapsRegistry
	"Register the receiver in the system's flaps registry"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl registerQuad: {#WsWorldStethoscopeMorph. #authoringPrototype.		'WorldStethoscope' translatedNoop. 'A device for analyzing phenomena as sounds'}
						forFlapNamed: 'Widgets'.
						cl registerQuad: {#WsWorldStethoscopeMorph.	#authoringPrototype.	'WorldStethoscope' translatedNoop.		'A device for analyzing phenomena as sounds' translatedNoop}
						forFlapNamed: 'PlugIn Supplies'.]! !

!WsWorldStethoscopeMorph class methodsFor: 'constants' stamp: 'tetha 9/9/2003 11:27'!
sortByFrequencyType

	^ #sortByFrequencyType! !

!WsWorldStethoscopeMorph class methodsFor: 'constants' stamp: 'tetha 9/9/2003 11:27'!
sortByLevelType

	^ #sortByLevelType! !

!WsWorldStethoscopeMorph class methodsFor: 'class initialization' stamp: 'ka 3/25/2005 21:28'!
unload
	"Unload the receiver from global registries"
	self environment
		at: #Flaps
		ifPresent: [:cl | cl unregisterQuadsWithReceiver: self]! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/9/2007 11:44'!
addButtonRow
	| row |
	row _ AlignmentMorph newRow vResizing: #shrinkWrap.
	row
		addMorphBack: (self buttonName: 'Menu' translated action: #invokeMenu).
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (self buttonName: 'Start' translated action: #start).
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (self buttonName: 'Stop' translated action: #stop).
	row addMorphBack: (Morph new extent: 12 @ 1;
			 color: Color transparent).
	self addMorphBack: row.
	^ row fullBounds.! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/16/2008 14:06'!
addControlsIn: aPoint
	| row |
	row _ AlignmentMorph newRow color: color;
				 layoutInset: 0;
				 "wrapCentering: #center;"
				 listDirection: #topToBottom;
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 height: aPoint y + 2.
	row name: #adjustments.
	row
		addMorphBack: (self
				buildSliderFor: #cutOffLevel
				min: model cutOffLevelMinValue
				max: model cutOffLevelMaxValue
				label: 'cut off level' translated in: aPoint).
	row
		addMorphBack: (self
				buildSliderFor: #offset
				min: model offsetMinValue
				max: model offsetMaxValue
				label: 'calibration  ' translated in: aPoint).
	self addMorphBack: row.
	row hide.
! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'ka 5/31/2007 23:44'!
addCustomMenuItems: aMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand."

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu addUpdating: #sortByLevelString action: #sortByLevel.
	aMenu addUpdating: #sortByFrequencyString action: #sortByFrequency.
	aMenu addLine.
	aMenu addUpdating: #rangeFinderModeString action: #toggleRangeFinderMode.! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/23/2008 14:39'!
addDataGraph

	| graph |
	graph := WsSignalGraphMorph new extent: self graphExtent.
	graph setNameTo: 'Data' translated.
	graph dataType: #signal.
	graph data: (OrderedCollection with: 0).
	graph model: model.
	model addView: graph.
	graph openInHand.
! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/23/2008 14:39'!
addSignalGraph

	| graph |
	graph := WsGraphMorph new extent: self graphExtent.
	graph setNameTo: 'Signal' translated.
	graph dataType: #signal.
	graph data: (Array with: 0 with: 0 with: 0 with: 0).
	graph model: model.
	model addView: graph.
	graph openInHand.
! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/23/2008 14:37'!
addSonogram

	| graph |
	graph := WsSonogram new extent: self graphExtent.
	graph setNameTo: 'Sonogram' translated.
	graph scrollDelta: self graphExtent x.
	graph model: model.
	model addView: graph.
	graph openInHand.
! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/23/2008 14:40'!
addSpectrumGraph

	| graph |
	graph := WsGraphMorph new extent: self graphExtent.
	graph setNameTo: 'Spectrum' translated.
	graph dataType: #spectrum.
	graph minVal: 0.
	graph data: (FloatArray new: 0).
	graph maxVal: 500000.
	graph model: model.
	model addView: graph.
	graph openInHand.
! !

!WsWorldStethoscopeMorph methodsFor: 'private' stamp: 'yo 7/9/2007 11:58'!
adjustmentsString
	| morph |
	morph _ self submorphNamed: #adjustments.
	^ morph isNil
		ifTrue: [false]
		ifFalse: [morph visible
				ifTrue: ['hide adjustments' translated]
				ifFalse: ['show adjustments' translated]]! !

!WsWorldStethoscopeMorph methodsFor: 'private' stamp: 'yo 7/11/2008 16:12'!
buildSliderFor: aspectSymbol min: minNumber max: maxNumber label: labelString in: aPoint
	| slider row |
	slider _ SimpleSliderMorph new color: Color gray;
				extent: (aPoint x * 0.75) asInteger@(aPoint y*0.6) asInteger;
				 target: self;
				 actionSelector: (aspectSymbol , ':') asSymbol;
				 minVal: minNumber;
				 maxVal: maxNumber;
				 adjustToValue: (model perform: aspectSymbol);
				 name: aspectSymbol.
	row _ AlignmentMorph newRow color: color;
				 layoutInset: 0;
				 wrapCentering: #center;
				 hResizing: #spaceFill;
				 vResizing: #rigid;
				 height: aPoint y + 2.
	row
		addMorphBack: (StringMorph contents: labelString font: Preferences standardEToysFont).
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (self buttonName: '-' action: aspectSymbol , 'Decrease').
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row addMorphBack: slider.
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (self buttonName: '+' action: aspectSymbol , 'Increase').
	^row! !

!WsWorldStethoscopeMorph methodsFor: 'private' stamp: 'sw 9/5/2007 15:26'!
buttonName: aString action: aSymbol

	^ SimpleButtonMorph new
		target: self;
		label: aString font: Preferences standardEToysButtonFont;
		actionSelector: aSymbol
! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 6/1/2007 18:37'!
cutOffLevel
	^ model cutOffLevel! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'ka 9/10/2003 18:15'!
cutOffLevelDecrease
	| newValue slider |
	newValue _ self cutOffLevel - 1000.
	self cutOffLevel: newValue.
	slider _ self submorphNamed: #cutOffLevel.
	slider value: newValue / self cutOffLevelMaxValue! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'ka 9/10/2003 18:16'!
cutOffLevelIncrease
	| newValue slider |
	newValue _ self cutOffLevel + 1000.
	self cutOffLevel: newValue.
	slider _ self submorphNamed: #cutOffLevel.
	slider value: newValue / self cutOffLevelMaxValue! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 6/1/2007 18:37'!
cutOffLevel: number 
	model cutOffLevel: number! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'yo 7/20/2008 13:40'!
defaultFloatPrecisionFor: aGetSelector

	(#(#getUpdateInterval  ) includes: aGetSelector)
		ifTrue: [^ 0.01].
	^ super defaultFloatPrecisionFor: aGetSelector.
	! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/11/2008 16:39'!
delete

	model ifNotNil: [model removeView: self].
	super delete.
! !

!WsWorldStethoscopeMorph methodsFor: 'phone utilities' stamp: 'ka 12/28/2006 02:04'!
dialNumber
	^ model dialNumber! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 14:44'!
directModeReadOut
	^ model directModeReadOut! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:02'!
frequency1
	^ model frequency1! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:03'!
frequency2
	^ model frequency2! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:03'!
frequency3
	^ model frequency3! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/11/2008 18:58'!
graphExtent

	^ 400@300.
! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/20/2008 13:29'!
initialize
	| full |
	super initialize.
	model _ WsWorldStethoscope default.
	model initialize.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	borderWidth := 2.
	self listDirection: #topToBottom.
	full _ self addButtonRow.
	submorphs last addMorphBack: (self inputModeButtonRow).
	submorphs last addMorphBack: (self makeStatusLightIn: full extent).

	self addControlsIn: full extent.
	biasModeLight color: (model biasInput ifTrue: [Color yellow] ifFalse: [Color lightGray]).
! !

!WsWorldStethoscopeMorph methodsFor: 'initialization' stamp: 'yo 7/17/2008 20:41'!
inputModeButtonRow
	| row |
	row _ AlignmentMorph newRow vResizing: #shrinkWrap.
	row addMorphBack: (Morph new extent: 10 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (directModeLight _ self buttonName: 'AC ' translated action: #toggleDirectMode).
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	row
		addMorphBack: (biasModeLight _ self buttonName: 'Bias' translated action: #toggleBias).
	row addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	^ row
! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/15/2008 10:09'!
invokeMenu
	| aMenu graphMenu |
	aMenu _ MenuMorph new.
	aMenu add: 'set sampling rate' translated target: self action: #setSamplingRate.
	aMenu add: 'set FFT size' translated target: self action: #setFFTSize.
	aMenu add: self adjustmentsString target: self action: #toggleAdjustments.

	graphMenu _ MenuMorph new.
	graphMenu add: 'sonogram' translated target: self action: #addSonogram.
	graphMenu add: 'signal' translated target: self action: #addSignalGraph.
	graphMenu add: 'spectrum' translated target: self action: #addSpectrumGraph.
	graphMenu add: 'data' translated target: self action: #addDataGraph.
	aMenu add: 'add a graph...' translated subMenu: graphMenu.

	aMenu invokeModal.! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:03'!
level1
	^ model level1! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:03'!
level2
	^ model level2! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/28/2006 02:03'!
level3
	^ model level3! !

!WsWorldStethoscopeMorph methodsFor: 'private' stamp: 'yo 7/9/2007 11:54'!
makeStatusLightIn: aPoint
	| label h w |
	h _ aPoint x min: aPoint y.
	w _ h * 1.
	statusLight _ Morph new extent: w @ h.
	statusLight color: Color gray.
	label _ StringMorph contents: 'On' translated font: Preferences standardEToysFont.
	label position: statusLight center - (label extent // 2).
	statusLight addMorph: label.
	^ statusLight! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'kfr 6/16/2010 23:12'!
offset
	^model offset! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/11/2008 16:09'!
offsetDecrease
	| newValue slider |
	model offsetDecrease.
	newValue := model offset.
	slider := self submorphNamed: #offset.
	slider value: newValue + model offsetMinValue negated / (model offsetMaxValue - model offsetMinValue)! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/11/2008 16:10'!
offsetIncrease
	| newValue slider |
	model offsetIncrease.
	newValue _ model offset.
	slider _ self submorphNamed: #offset.
	slider value: newValue + model offsetMinValue negated / (model offsetMaxValue - model offsetMinValue)! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'kfr 6/16/2010 23:12'!
offset: number 
	model offset: number! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/31/2006 01:50'!
passOver
	^ model passOver! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/31/2006 01:51'!
passOver: number 
	model passOver: number! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/31/2006 01:51'!
passUnder
	^ model passUnder! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'ka 12/31/2006 01:51'!
passUnder: number 
	model passUnder: number! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/16/2008 14:41'!
rangeFinderModeString
	| label |
	label _ 'range finder mode' translated.
	^ model isRangeFinderMode
		ifTrue: ['<on>' , label]
		ifFalse: ['<off>' , label]! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/11/2008 16:16'!
setFFTSize

	^ model setFFTSize
! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/11/2008 16:16'!
setSamplingRate

	^ model setSamplingRate
! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/16/2008 14:41'!
sortByFrequencyString
	| label |
	label _ 'sort by frequency' translated.
	^ model isSortByFrequency
		ifTrue: ['<on>' , label]
		ifFalse: ['<off>' , label]! !

!WsWorldStethoscopeMorph methodsFor: 'menus' stamp: 'yo 7/16/2008 14:41'!
sortByLevelString
	| label |
	label _ 'sort by level' translated.
	^ model isSortByLevel
		ifTrue: ['<on>' , label]
		ifFalse: ['<off>' , label]! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'ka 12/31/2006 00:28'!
start
	model start! !

!WsWorldStethoscopeMorph methodsFor: 'stepping' stamp: 'yo 7/14/2008 16:48'!
step
	model isListening
		ifTrue: [statusLight color: Color yellow]
		ifFalse: [statusLight color: Color gray].
	model processBuffer! !

!WsWorldStethoscopeMorph methodsFor: 'stepping' stamp: 'yo 7/14/2008 16:49'!
stepTime

	^ 0.
! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'ka 12/31/2006 00:28'!
stop
	model stop! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'tetha 10/23/2003 17:01'!
toggleAdjustments
	| adjustments |
	adjustments _ self submorphNamed: #adjustments.
	adjustments visible
		ifTrue: [adjustments hide]
		ifFalse: [adjustments show].
	self layoutChanged! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/16/2008 14:33'!
toggleBias

	model biasInput: model biasInput not.
	biasModeLight color: (model biasInput ifTrue: [Color yellow] ifFalse: [Color lightGray]).
! !

!WsWorldStethoscopeMorph methodsFor: 'menu and buttons' stamp: 'yo 7/16/2008 14:36'!
toggleDirectMode

	model directInputMode: model directInputMode not.
	directModeLight label: (model directInputMode ifTrue: ['DC' translated] ifFalse: ['AC' translated]) font: Preferences standardButtonFont.! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'yo 7/20/2008 13:34'!
updateInterval

	^ model updateInterval
! !

!WsWorldStethoscopeMorph methodsFor: 'accessing' stamp: 'yo 7/20/2008 13:36'!
updateInterval: aNumber

	model updateInterval: aNumber! !

ImageMorph subclass: #WsGraphMorph
	instanceVariableNames: 'graphType dataType model data dataColor cursor cursorColor cursorColorAtZeroCrossings startIndex relativeScale minVal maxVal imageFormValid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsGraphMorph class methodsFor: 'scripting' stamp: 'yo 7/16/2008 15:30'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(
	(color (
		(slot dataColor 'The color hue of the data' Color readWrite Player getDataColor  Player  setDataColor:)
	))

	(sampling (
(slot cursor 	'The current cursor location, wrapped back to the beginning if appropriate' Number	 readWrite Player getCursor Player setCursorWrapped:)
(slot sampleAtCursor	'The sample value at the current cursor location' Number readWrite Player getSampleAtCursor Player setSampleAtCursor:)
(slot lastValue 'The last value obtained' Number readWrite	Player getLastValue Player setLastValue:)
(command clear 'Clear the graph of current contents')
(slot relativeScale 'Whether the display scale is relative to the actual maximum and minimum values in data' Boolean readWrite Player getRelativeScale Player setRelativeScale:)
(slot maxVal 'The maximum of the range drawn in the graph' Number readWrite Player getMaxVal Player setMaxVal:)
(slot maxVal 'The minimum of the range drawn in the graph' Number readWrite Player getMinVal Player setMinVal:))))
! !

!WsGraphMorph methodsFor: 'sound' stamp: 'yo 7/15/2008 01:00'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/14/2008 23:00'!
appendValue: aPointOrNumber

	| newVal |
	newVal _ self asNumber: aPointOrNumber.
	(data isKindOf: OrderedCollection)
		ifFalse: [data _ data copyWith: newVal]
		ifTrue: [data addLast: newVal].
	relativeScale ifTrue: [
		newVal < minVal ifTrue: [minVal _ newVal].
		newVal > maxVal ifTrue: [maxVal _ newVal].
	].
	self cursor: data size.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/14/2008 23:52'!
centerCursor
	"Scroll so that the cursor is as close as possible to the center of my window."

	| w |
	w _ self width - (2 * self borderWidth).
	self startIndex: ((cursor - (w // 2)) max: 1).
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
clear

	self startIndex: 1.
	self cursor: 1.
	self data: OrderedCollection new.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 23:57'!
color

	^ color
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 23:57'!
color: aColor

	color _ aColor.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'e-toy support' stamp: 'yo 7/12/2008 13:59'!
cursor

	^ cursor
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
cursorAtEnd

	^ cursor truncated >= data size
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
cursorColor

	^ cursorColor
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
cursorColorAtZeroCrossing

	^ cursorColorAtZeroCrossings
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
cursorColorAtZeroCrossings: aColor

	cursorColorAtZeroCrossings _ aColor.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
cursorColor: aColor

	cursorColor _ aColor.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/15/2008 10:52'!
cursorPosition

	| ptr r |
	ptr _ (cursor asInteger max: 1) min: data size.
	r _ self innerBounds.
	^ r left + ptr - startIndex.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 10:40'!
cursorWrapped: aNumber

	| sz |
	cursor ~= aNumber ifTrue: [
		cursor _ aNumber.
		sz _ data size.
		sz = 0
			ifTrue: [cursor _ 1]
			ifFalse: [
				((cursor >= (sz + 1)) or: [cursor < 0]) ifTrue: [
					cursor _ cursor - ((cursor // sz) * sz)].
				cursor < 1 ifTrue: [cursor _ sz + cursor]].
		"assert: 1 <= cursor < data size + 1"
	].
! !

!WsGraphMorph methodsFor: 'e-toy support' stamp: 'yo 7/16/2008 10:40'!
cursor: aNumber

	| truncP |
	cursor ~= aNumber ifTrue:  [
		cursor _ aNumber.
		truncP _ aNumber truncated.
		truncP > data size ifTrue: [cursor _ data size].
		truncP < 0 ifTrue: [cursor _ 1].
		self keepIndexInView: truncP.
	].
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
data

	^ data
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
dataColor

	^ dataColor
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
dataColor: aColor

	dataColor _ aColor.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 10:10'!
dataType: aSymbol

	dataType _ aSymbol.
	self resetTo: self extent.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 22:59'!
data: aCollection

	data _ aCollection.

	relativeScale ifTrue: [
		data do: [:x |
			x < minVal ifTrue: [minVal _ x].
			x > maxVal ifTrue: [maxVal _ x]]].

	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'e-toy support' stamp: 'yo 7/15/2008 01:11'!
delete

	super delete.
	model ifNotNil: [model removeView: self].
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/15/2008 13:45'!
drawBarDataOn: aCanvas

	| yScale baseLine x start end value left top bottom right rightBound borderWidth |
	borderWidth _ self borderWidth.
	data isEmpty ifTrue: [^ self].
	maxVal = minVal ifTrue: [
		yScale _ 1.
	] ifFalse: [
		yScale _ (bounds height - (2 * borderWidth)) asFloat / (maxVal - minVal)].
	baseLine _ bounds bottom - borderWidth + (minVal * yScale) truncated.
	rightBound _ (bounds right - borderWidth) truncated.
	x _ (bounds left + borderWidth) truncated.
	start _ (startIndex asInteger max: 1) min: data size.
	end _ (start + bounds width) min: data size.
	start to: end do: [:i |
		left _ x. right _ x + 1.
		right > rightBound ifTrue: [^ self].
		value _ (data at: i) asFloat.
		value >= 0.0 ifTrue: [
			top _ baseLine - (yScale * value) truncated.
			bottom _ baseLine.
		] ifFalse: [
			top _ baseLine.
			bottom _ baseLine - (yScale * value) truncated].
		aCanvas fillRectangle: (left@top corner: right@bottom) color: dataColor.
		x _ x + 1].
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/16/2008 12:44'!
drawCursorOn: aCanvas

	| ptr x r c |
	ptr _ (cursor asInteger max: 1) min: data size.
	c _ cursorColor.
	((ptr > 1) and: [ptr < data size]) ifTrue: [
		(data at: ptr) sign ~= (data at: ptr + 1) sign
			ifTrue: [c _ cursorColorAtZeroCrossings]].
	r _ self innerBounds.
	x _ r left + ptr - startIndex.
	((x >= r left) and: [x < r right]) ifTrue: [
		aCanvas fillRectangle: (x@r top corner: x + 1@r bottom) color: c].
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/15/2008 15:12'!
drawDataOn: aCanvas

	aCanvas fillColor: self color.
	graphType = #bar ifTrue: [
		^ self drawBarDataOn: aCanvas].
	graphType = #line ifTrue: [
		^ self drawLineDataOn: aCanvas].
	self error: 'unknown graph type'.
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/15/2008 13:45'!
drawLineDataOn: aCanvas

	| yScale baseLine x start end polygon borderWidth |
	borderWidth _ self borderWidth.
	data isEmpty ifTrue: [^ self].
	maxVal = minVal ifTrue: [
		yScale _ 1.0.
	] ifFalse: [
		yScale _ (bounds height - (2 * borderWidth)) asFloat / (maxVal - minVal)].

	baseLine _ ((bounds bottom - borderWidth + (minVal * yScale)) min: (bounds bottom - borderWidth)).
	x _ (bounds left + borderWidth) truncated - 2.
	start _ (startIndex asInteger max: 1) min: data size.
	end _ (start + bounds width) min: data size.
	polygon _ WriteStream on: (Array new: end - start + 2).
	polygon nextPut: (x _ x + 1)@baseLine.
	start to: end do: [:i |
		polygon nextPut: (x _ x + 1)@((data at: i) * yScale negated + baseLine)].
	polygon nextPut: (x@baseLine).
	polygon _ polygon contents.

	aCanvas drawPolygon: polygon color: Color transparent borderWidth: 1 borderColor: dataColor.
	aCanvas fillRectangle: ((bounds left + borderWidth@baseLine) extent: bounds width@1) color: Color black.! !

!WsGraphMorph methodsFor: 'drawing' stamp: 'yo 7/14/2008 23:53'!
drawOn: aCanvas 
	| c |
	imageFormValid ifFalse:
			[c := image getCanvas.
			c translateBy: bounds origin negated
				during: [:tempCanvas | self drawDataOn: tempCanvas].
			imageFormValid := true].
	super drawOn: aCanvas.
	self drawCursorOn: aCanvas! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 00:08'!
extent: aPoint

	self resetTo: aPoint.
! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/16/2008 10:40'!
flushCachedForm

	imageFormValid _ false.
	self changed.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 00:09'!
graphType: aSymbol

	graphType _ aSymbol.
	self resetTo: self extent.
! !

!WsGraphMorph methodsFor: 'event handling' stamp: 'yo 7/12/2008 13:59'!
handlesMouseDown: evt

	evt shiftPressed
		ifTrue: [^ super handlesMouseDown: evt]
		ifFalse: [^ true].
! !

!WsGraphMorph methodsFor: 'initialization' stamp: 'yo 7/16/2008 12:48'!
initialize
	"initialize the state of the receiver"
	super initialize.
	""
	graphType _ #bar.
	self borderWidth: 0.
	color _ Color white.
	dataColor _ Color black.

	cursor _ 1.
	"may be fractional"
	cursorColor _ Color red.
	cursorColorAtZeroCrossings _ Color red.
	startIndex _ 1.
	maxVal _ 32767.
	minVal _ -32768.
	relativeScale _ false.

	self extent: 400 @ 300.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
interpolatedValueAtCursor
	| sz prev frac next |
	data isEmpty ifTrue: [^0].
	sz := data size.
	cursor < 0 ifTrue: [^data first].	"just to be safe, though cursor shouldn't be negative"
	prev := cursor truncated.
	frac := cursor - prev.
	prev < 1 ifTrue: [prev := sz].
	prev > sz ifTrue: [prev := 1].
	"assert: 1 <= prev <= sz"
	frac = 0 ifTrue: [^data at: prev].	"no interpolation needed"

	"interpolate"
	next := prev = sz ifTrue: [1] ifFalse: [prev + 1].
	^(1.0 - frac) * (data at: prev) + (frac * (data at: next))! !

!WsGraphMorph methodsFor: 'private' stamp: 'yo 7/14/2008 23:51'!
keepIndexInView: index

	| w newStart |
	w _ bounds width - (2 * self borderWidth).
	index < startIndex ifTrue: [
		newStart _ index - w + 1.
		^ self startIndex: (newStart max: 1)].
	index > (startIndex + w) ifTrue: [
		^ self startIndex: (index min: data size)].
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
lastValue
	data isEmpty ifTrue: [^0].
	^data last! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
lastValue: aNumber

	self appendValue: aNumber.
! !

!WsGraphMorph methodsFor: 'layout' stamp: 'yo 7/14/2008 23:49'!
layoutChanged

	super layoutChanged.
	imageFormValid _ false.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
loadSineWave

	self loadSoundData: SoundBuffer sineTable.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
loadSoundData: aCollection

	| scale absV newData |
	scale _ 0.
	aCollection do: [:v | (absV _ v abs) > scale ifTrue: [scale _ absV]].
	scale _ 100.0 / scale.
	newData _ OrderedCollection new: aCollection size.
	1 to: aCollection size do: [:i | newData addLast: (scale * (aCollection at: i))].

	self data: newData.
	self startIndex: 1.
	self cursor: 1.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
loadSound: aSound

	self loadSoundData: aSound samples.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 19:55'!
maxVal

	^ maxVal
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 10:39'!
maxVal: aNumber

	maxVal _ aNumber.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 19:55'!
minVal

	^ minVal
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 19:55'!
minVal: aNumber

	minVal _ aNumber.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 00:00'!
model: anObject

	model _ anObject.
! !

!WsGraphMorph methodsFor: 'event handling' stamp: 'yo 7/14/2008 23:53'!
mouseMove: evt

	| x w |
	x _ evt cursorPoint x - (bounds left + self borderWidth).
	w _ self width - (2 * self borderWidth).

	self changed.
	x < 0 ifTrue: [
		cursor _ startIndex + (3 * x).
		cursor _ (cursor max: 1) min: data size.
		^ self startIndex: cursor].
	x > w ifTrue: [
		cursor _ startIndex + w + (3 * (x - w)).
		cursor _ (cursor max: 1) min: data size.
		^ self startIndex: cursor - w].

	cursor _ ((startIndex + x) max: 1) min: data size.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
play
	self playOnce! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
playOnce

	| scale absV scaledData |
	data isEmpty ifTrue: [^ self].  "nothing to play"
	scale _ 1.
	data do: [:v | (absV _ v abs) > scale ifTrue: [scale _ absV]].
	scale _ 32767.0 / scale.
	scaledData _ SoundBuffer newMonoSampleCount: data size.
	1 to: data size do: [:i | scaledData at: i put: (scale * (data at: i)) truncated].
	SoundService default playSampledSound: scaledData rate: 11025.
! !

!WsGraphMorph methodsFor: 'e-toy support' stamp: 'yo 7/16/2008 15:00'!
processData: buf

	self data: buf.
	self changed.
! !

!WsGraphMorph methodsFor: 'sound' stamp: 'yo 7/12/2008 13:59'!
readDataFromFile

	| fileName |
	fileName _ FillInTheBlank
		request: 'File name?' translated
		initialAnswer: ''.
	fileName isEmpty ifTrue: [^ self].
	(StandardFileStream isAFileNamed: fileName) ifFalse: [
		^ self inform: 'Sorry, I cannot find that file' translated].
	self data: (SampledSound fromAIFFfileNamed: fileName) samples.

! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 22:54'!
relativeScale

	^ relativeScale
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/14/2008 22:54'!
relativeScale: aBoolean

	relativeScale _ aBoolean! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 15:20'!
resetTo: aPoint

	super image: (Form extent: aPoint depth: 16).
	image fillColor: self color.
! !

!WsGraphMorph methodsFor: 'commands' stamp: 'yo 7/12/2008 13:59'!
reverse

	data _ data reversed.
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 10:35'!
setMaxVal: aNumber

	self maxVal: aNumber.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 10:36'!
setMinVal: aNumber

	self minVal: aNumber.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
startIndex

	^ startIndex
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 10:39'!
startIndex: aNumber

	startIndex ~= aNumber ifTrue:  [
		startIndex _ aNumber asInteger.
		self flushCachedForm].
! !

!WsGraphMorph methodsFor: 'stepping and presenter' stamp: 'yo 7/15/2008 14:05'!
step
	"Make a deferred damage rectangle if I've changed. This allows applications to call methods that invalidate my display at high-bandwidth without paying the cost of doing the damage reporting on ever call; they can merely set hasChanged to true."
"
	super step.
	hasChanged isNil ifTrue: [hasChanged := false].
	hasChanged 
		ifTrue: 
			[self changed.
			hasChanged := false]"! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
valueAtCursor

	data isEmpty ifTrue: [^ 0].
	^ data at: ((cursor truncated max: 1) min: data size)
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/12/2008 13:59'!
valueAtCursor: aPointOrNumber

	data isEmpty ifTrue: [^ 0].
	data
		at: ((cursor truncated max: 1) min: data size)
		put: (self asNumber: aPointOrNumber).
	self flushCachedForm.
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/15/2008 10:11'!
wantsFFTData

	^ dataType ~= #signal
! !

!WsGraphMorph methodsFor: 'accessing' stamp: 'yo 7/16/2008 14:56'!
wantsRawData

	^ true.
! !

WsGraphMorph subclass: #WsSignalGraphMorph
	instanceVariableNames: 'capacity mouseDown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 14:27'!
appendValue: aPointOrNumber

	| newVal |
	newVal _ self asNumber: aPointOrNumber.
	(data isKindOf: OrderedCollection)
		ifFalse: [data _ data copyWith: newVal]
		ifTrue: [data addLast: newVal].
	relativeScale ifTrue: [
		newVal < minVal ifTrue: [minVal _ newVal].
		newVal > maxVal ifTrue: [maxVal _ newVal].
	].
	data size > capacity ifTrue: [
		self data: (data copyFrom: data size - (capacity // 2) + 1 to: data size).
		self changed.
	].
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 11:19'!
capacity: aNumber

	capacity _ aNumber.
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 13:33'!
handlesMouseUp: evt

	evt shiftPressed
		ifTrue: [^ super handlesMouseUp: evt]
		ifFalse: [^ true].
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 13:31'!
initialize

	super initialize.
	graphType _ #line.
	self capacity: 20000.
	mouseDown _ false.
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 13:32'!
mouseMove: evt

	super mouseMove: evt.
	mouseDown _ true.
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/16/2008 10:39'!
mouseUp: evt

	super mouseUp: evt.
	mouseDown _ false.
	self flushCachedForm.
	self cursor: data size.
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/16/2008 15:00'!
processData: d

	| oldCursorPosition borderWidth yScale baseLine oldY newY c lastPos |
	self appendValue: d.
	mouseDown ifFalse: [self cursor: data size].
	oldCursorPosition _ data size - 1 - startIndex.

	borderWidth _ self borderWidth.
	maxVal = minVal ifTrue: [
		yScale _ 1.0.
	] ifFalse: [
		yScale _ (bounds height - (2 * borderWidth)) asFloat / (maxVal - minVal)].
	baseLine _ ((bounds height - borderWidth + (minVal * yScale)) min: (bounds height - borderWidth)).
	oldY _ (data at: data size - 1) * yScale negated + baseLine.
	newY _ (data at: data size) * yScale negated + baseLine.

	lastPos _ oldCursorPosition@oldY.
	c _ image getCanvas asBalloonCanvas.
	c line: lastPos to: (oldCursorPosition+1@newY) width: 1 color: dataColor.
	lastPos _ lastPos + self position.
	self invalidRect: (lastPos x@bounds top corner: lastPos x + 2@bounds bottom).
! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/15/2008 09:59'!
wantsFFTData

	^ false

! !

!WsSignalGraphMorph methodsFor: 'all' stamp: 'yo 7/16/2008 16:24'!
wantsRawData

	^ false

! !

ImageMorph subclass: #WsSonogram
	instanceVariableNames: 'model dataColor lastX scrollDelta pixValMap allOne words'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsSonogram class methodsFor: 'as yet unclassified' stamp: 'kfr 8/28/2011 01:09'!
additionsToViewerCategories
	"Answer a list of (<categoryName> <list of category specs>) pairs that characterize the phrases this kind of morph wishes to add to various Viewer categories."

	^ #(
	(color (
			(slot dataColor 'The color hue of the data' Color readWrite Player getDataColor  Player  setDataColor:)
	))

	(sampling (
			(slot scrollDelta 'The horizontal scrolling stride when data is going off the edge.' Number readWrite Player getScrollDelta Player setScrollDelta:))))! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:09'!
color

	^ color
! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:12'!
color: aColor

	color _ aColor.
	self setUpColorMap! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:10'!
dataColor

	^ dataColor
! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:12'!
dataColor: aColor

	dataColor _ aColor.
	self setUpColorMap
! !

!WsSonogram methodsFor: 'others' stamp: 'yo 7/14/2008 19:50'!
delete

	super delete.
	model ifNotNil: [model removeView: self].
! !

!WsSonogram methodsFor: 'others' stamp: 'yo 7/16/2008 15:26'!
extent: newExtent
	| zeros |
	super image: (Form extent: newExtent depth: 16).
	allOne := ByteArray new: newExtent y withAll: 1.
	words := Bitmap new: newExtent y.
	lastX := -1.
	zeros _ KedamaFloatArray new: self height withAll: 0.
	self width timesRepeat: [self processData: zeros].
! !

!WsSonogram methodsFor: 'others' stamp: 'yo 7/16/2008 15:27'!
initialize

	super initialize.
	color _ Color white.
	dataColor _ Color black.
	self setUpColorMap.
! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/14/2008 19:50'!
model: anObject

	model _ anObject.
! !

!WsSonogram methodsFor: 'processing' stamp: 'yo 7/16/2008 15:00'!
processData: dataArray

	| normVal r pred quad warp source |
	normVal := KedamaFloatArray new: dataArray size.
	normVal replaceFrom: 1 to: dataArray size with: dataArray startingAt: 1.
	normVal := normVal collect: [:v | v sqrt].	"square root compresses dynamic range"
	normVal /= 400.0.
	pred := PredicatedArray predicates: (normVal eToysLT: 0.0) values: normVal type: #Number.
	pred atAllPut: 0.0.
	pred predicates: (normVal eToysGT: 1.0).
	pred atAllPut: 1.0.
	normVal *= 255.0.
	(allOne isNil or: [allOne size ~= normVal size or: [words size ~= normVal size]]) ifTrue: [
		words := Bitmap new: normVal size.
		allOne := ByteArray new: words size withAll: 1
	].
	pred := PredicatedArray predicates: allOne values: words.
	pred type: #Number.
	pred replaceFrom: 1 to: words size with: normVal startingAt: 1.
	source := Form extent: 4@words size depth: 8 bits: words.
	(lastX := lastX + 1) > (image width - 1) ifTrue: [self scroll].

	quad := Array with: 3@image height with: 3@0 with: 2@0 with: 2@image height.
	warp := WarpBlt toForm: image.
	warp combinationRule: Form over;
		sourceForm: source;
		sourceQuad: quad destRect: (r := lastX @ 0 extent: 1 @ image height);
		colorMap: pixValMap;
		warpBits.
	self invalidRect: (r translateBy: self position)
! !

!WsSonogram methodsFor: 'others' stamp: 'yo 7/11/2008 19:24'!
scroll
	image copy: (scrollDelta@0 extent: (image width-scrollDelta)@image height)
			from: image to: 0@0 rule: Form over.
	lastX := lastX - scrollDelta.
	self changed! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:26'!
scrollDelta

	^ scrollDelta
! !

!WsSonogram methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:28'!
scrollDelta: aNumber

	scrollDelta _ aNumber min: self width max: 0.
! !

!WsSonogram methodsFor: 'others' stamp: 'yo 7/16/2008 15:11'!
setUpColorMap

	pixValMap _ ((1 to: 256) collect:
			[:i | (color mixed: (256-i)/255.0 with: dataColor) pixelValueForDepth: 16])
		as: Bitmap.

! !

!WsSonogram methodsFor: 'processing' stamp: 'yo 7/14/2008 17:58'!
wantsFFTData

	^ true.
! !

!PasteUpMorph methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/12/2004 23:33'!
dialNumber

	| stethoscope |
	stethoscope _ WsWorldStethoscope default.
	^ stethoscope dialNumber! !

!PasteUpMorph methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/12/2004 23:34'!
frequency
	| stethoscope |
	stethoscope _ WsWorldStethoscope default.
	^ stethoscope frequency! !

!PasteUpMorph methodsFor: '*WS-Sound-Interface' stamp: 'tetha 1/12/2004 23:33'!
level
	| stethoscope |
	stethoscope _ WsWorldStethoscope default.
	^ stethoscope level! !

!FloatArray methodsFor: '*WS-Sound-Primitives' stamp: 'ka 11/10/2003 22:11'!
bytesPerElement
	"Number of bytes in each item.  This multiplied by (self size)*8 gives the number of bits stored."
	^ 4! !

Object subclass: #WsSound
	instanceVariableNames: 'frequency level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Primitives'!

!WsSound class methodsFor: 'examples' stamp: 'ka 7/29/2003 22:27'!
example1
	"WsSound example1"
	^ self frequency: 1000 level: 10! !

!WsSound class methodsFor: 'examples' stamp: 'tetha 9/25/2003 17:52'!
example2
	"WsSound example2"
	| frequencies |
	frequencies _ #(261.6 293.6 329.6 349.2 392 440 493.8 523.3 ).
	^ frequencies
		collect: [:f | WsSound musicalScaleNameOf: f]! !

!WsSound class methodsFor: 'examples' stamp: 'tetha 9/25/2003 17:53'!
example3
	"WsSound example3"
	| frequencies |
	frequencies _ #(454 94324 898423 333 432 8586 1 2).
	^ frequencies
		collect: [:f | WsSound musicalScaleNameOf: f]! !

!WsSound class methodsFor: 'instance creation' stamp: 'ka 7/30/2003 00:34'!
frequency: frequency level: level 
	"WsSound frequency: 1000 level: 10"
	^ self new frequency: frequency level: level! !

!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:47'!
musicalScaleC0Frequency
	^ 16.351 ! !

!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:55'!
musicalScaleNameOf: aNumber
	| index |
	aNumber < self musicalScaleC0Frequency ifTrue: [^'unknown'].
	index _ (((aNumber / self musicalScaleC0Frequency) log:2) * 12) rounded \\ 12.
	^self musicalScaleNames at: index + 1! !

!WsSound class methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 18:51'!
musicalScaleNames
	^ #('C' 'C#' 'D' 'D#' 'E' 'F' 'F#' 'G' 'G#' 'A' 'A#' 'B' )! !

!WsSound class methodsFor: 'instance creation' stamp: 'ka 7/29/2003 22:20'!
new
	^ super new initialize! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
frequency
	^ frequency! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
frequency: aNumber 
	frequency _ aNumber! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/30/2003 00:33'!
frequency: frequencyNumber level: levelNumber 
	self frequency: frequencyNumber.
	self level: levelNumber! !

!WsSound methodsFor: 'initialize-release' stamp: 'ka 7/29/2003 22:19'!
initialize
	frequency _ level _ 0! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:14'!
level
	^ level! !

!WsSound methodsFor: 'accessing' stamp: 'ka 7/29/2003 22:15'!
level: aNumber 
	level _ aNumber! !

!WsSound methodsFor: 'musical scaling' stamp: 'tetha 9/25/2003 17:45'!
musicalScaleName

	^self class musicalScaleNameOf: self frequency! !

!WsSound methodsFor: 'printing' stamp: 'ka 7/29/2003 22:25'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	self frequency printOn: aStream.
	aStream nextPut: Character space.
	self level printOn: aStream.
	aStream nextPut: $)! !

Object subclass: #WsWorldStethoscope
	instanceVariableNames: 'soundInput fft sounds offset cutOffLevel sortType listening passOver passUnder passMask rangeFinderMode directInputMode representativeData biasInput totalSamplesInGiga totalSamples recordedCount wantsToRecord nextUpdateInGiga nextUpdate updateIntervalInSec views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WS-Sound-Interface'!

!WsWorldStethoscope class methodsFor: 'instance creation' stamp: 'yo 9/18/2008 01:58'!
default
	^ self new! !

!WsWorldStethoscope class methodsFor: 'constants' stamp: 'tetha 1/11/2004 23:15'!
sortByFrequencyType

	^ #sortByFrequencyType! !

!WsWorldStethoscope class methodsFor: 'constants' stamp: 'tetha 1/11/2004 23:15'!
sortByLevelType

	^ #sortByLevelType! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/11/2008 16:38'!
addView: aMorph

	self removeView: aMorph.
	views := views copyWith: aMorph.
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/16/2008 11:38'!
biasInput

	^ biasInput! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/16/2008 13:28'!
biasInput: aBoolean

	self directInputMode: directInputMode withBiasInput: aBoolean
! !

!WsWorldStethoscope methodsFor: 'private - updating' stamp: 'yo 7/14/2008 18:21'!
calcNext: inSec and: rate

	| next |
	recordedCount := recordedCount + 1.
	next := (recordedCount * rate * inSec) truncated.
	nextUpdateInGiga := next // 1000000000.
	nextUpdate := next \\ 1000000000.
! !

!WsWorldStethoscope methodsFor: 'sort setting' stamp: 'yo 7/20/2008 12:07'!
configureDirectInputMode: aBoolean bias: bias

	soundInput ifNotNil: [
		soundInput primSetDevice: 2 name: 'DC Mode Enable'.
		soundInput primSetSwitch: 2 captureFlag: false parameter: aBoolean.
		directInputMode _ soundInput primGetSwitch: 2 captureFlag: false channel: 0.
		directInputMode isInteger ifTrue: [directInputMode _ false].
		soundInput primSetDevice: 2 name: 'V_REFOUT Enable'.
		soundInput primSetSwitch: 2 captureFlag: false parameter: bias.
		biasInput _ soundInput primGetSwitch: 2 captureFlag: false channel: 0.
		biasInput isInteger ifTrue: [biasInput _ false].
		soundInput primSetDevice: 2 name: nil.
	].
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:56'!
cutOffLevel
	^ cutOffLevel! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:03'!
cutOffLevelDecrease
	| newValue |
	newValue _ self cutOffLevel - 1000.
	self cutOffLevel: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:03'!
cutOffLevelIncrease
	| newValue |
	newValue _ self cutOffLevel + 1000.
	self cutOffLevel: newValue.! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'ka 6/1/2007 00:51'!
cutOffLevelMaxValue
	^ 200000! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
cutOffLevelMinValue
	^ 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
cutOffLevel: number 
	cutOffLevel _ number! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
defaultCutOffLevel
	^ 10000! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
defaultOffset
	^ -30! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'ka 12/31/2006 01:02'!
defaultPassOver
	^ 20! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'ka 12/31/2006 01:00'!
defaultPassUnder
	^ 10000! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
dialNumber
	| permissibleRange lows highs lowFrequency highFrequency numbers index |
	permissibleRange _ self permissibleRange.
	lows _ self lowFrequencies.
	highs _ self highFrequencies.
	numbers _ self dialNumbers.
	lowFrequency _ nil.
	highFrequency _ nil.
	sounds
		do: [:each | 
			| frequency | 
			frequency _ each frequency rounded.
			lowFrequency isNil
				ifTrue: [lows
						detect: [:low | 
							lowFrequency _ low.
							(low - permissibleRange to: low + permissibleRange)
								includes: frequency]
						ifNone: [lowFrequency _ nil]].
			highFrequency isNil
				ifTrue: [highs
						detect: [:high | 
							highFrequency _ high.
							(high - permissibleRange to: high + permissibleRange)
								includes: frequency]
						ifNone: [highFrequency _ nil]]].
	lowFrequency isNil
		ifTrue: [^ ''].
	highFrequency isNil
		ifTrue: [^ ''].
	index _ (lows indexOf: lowFrequency)
				- 1 * 4
				+ (highs indexOf: highFrequency).
	^ (numbers at: index) asString! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
dialNumbers
	^ '123A456B789C*0#D' copy! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/15/2008 15:25'!
directInputMode

	^ directInputMode
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/16/2008 13:28'!
directInputMode: aBoolean

	self directInputMode: aBoolean withBiasInput: biasInput
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/16/2008 14:37'!
directInputMode: aBoolean withBiasInput: bias

	self configureDirectInputMode: aBoolean bias: bias.
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/16/2008 15:05'!
directModeReadOut

	^ representativeData
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/12/2004 23:36'!
frequency
	^ self frequency1! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency1
	^ sounds first frequency max: 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency2
	^ sounds second frequency max: 0! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
frequency3
	^ sounds third frequency max: 0! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:54'!
highFrequencies
	^ #(1209 1336 1477 1633 ) copy! !

!WsWorldStethoscope methodsFor: 'initialization' stamp: 'yo 9/23/2008 16:34'!
initialize

	super initialize.
	views := Array new: 0.
	fft _ FFT new: 512.
	self cutOffLevel: self defaultCutOffLevel.
	self offset: self defaultOffset.
	self passOver: self defaultPassOver.
	self passUnder: self defaultPassUnder.
	directInputMode _ false.
	biasInput _ true.
	representativeData _ 0.
	sounds _ Array
				with: WsSound new
				with: WsSound new
				with: WsSound new.
	soundInput _ SoundInputStream new samplingRate: 22050.
	self sortByLevel.

	totalSamplesInGiga _ 0.
	totalSamples _ 0.
	recordedCount _ 0.
	updateIntervalInSec _ 0.25.		"in seconds."
	wantsToRecord _ false.
	self calcNext: updateIntervalInSec and: soundInput samplingRate.

	self addView: self.

	self rangeFinderModeOff! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/12/2004 23:30'!
isListening
	^ listening == true! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'ka 5/31/2007 23:25'!
isRangeFinderMode
	^ rangeFinderMode == true! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/11/2004 22:59'!
isSortByFrequency

	^ sortType == self class sortByFrequencyType! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'tetha 1/11/2004 22:59'!
isSortByLevel

	^ sortType == self class sortByLevelType! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/12/2004 23:37'!
level
	^ self level1! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:57'!
level1
	^ sounds first level! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
level2
	^ sounds second level! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
level3
	^ sounds third level! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:55'!
lowFrequencies
	^ #(697 770 852 941 ) copy! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
offset
	^ offset! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
offsetDecrease
	| newValue |
	newValue _ self offset - 1.
	self offset: newValue.! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
offsetIncrease
	| newValue |
	newValue _ self offset + 1.
	self offset: newValue.! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
offsetMaxValue
	^ 200! !

!WsWorldStethoscope methodsFor: 'constants' stamp: 'tetha 1/11/2004 22:09'!
offsetMinValue
	^ -200! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'tetha 1/11/2004 21:58'!
offset: number 
	offset _ number! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:57'!
passOver
	^ passOver! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passOver: number 
	passOver _ number! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passUnder
	^ passUnder! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 12/31/2006 00:58'!
passUnder: number 
	passUnder _ number! !

!WsWorldStethoscope methodsFor: 'phone utilities' stamp: 'tetha 1/11/2004 22:55'!
permissibleRange
	^ 30! !

!WsWorldStethoscope methodsFor: 'processing' stamp: 'yo 7/14/2008 19:27'!
processBuffer
	| bufCount buffer |
	soundInput bufferCount = 0 ifTrue: [^ self].

	bufCount _ 0.
	[soundInput bufferCount > 0] whileTrue: [
		buffer _ soundInput nextBufferOrNil.
		bufCount := bufCount + buffer size.
	].

	self processBuffer: buffer at: bufCount.
! !

!WsWorldStethoscope methodsFor: 'processing' stamp: 'yo 7/28/2008 13:08'!
processBuffer: rawArray at: samplesCount

	| dataArray remSamples newTotalSamplesInGiga newTotalSamples |
	newTotalSamplesInGiga := totalSamplesInGiga + ((remSamples := samplesCount + totalSamples) // 1000000000).
	newTotalSamples := remSamples \\ 1000000000.

	wantsToRecord := wantsToRecord or: [self timePastTotalInGiga: newTotalSamplesInGiga and: newTotalSamples].
	totalSamplesInGiga := newTotalSamplesInGiga.
	totalSamples := newTotalSamples.

	wantsToRecord ifTrue: [
		dataArray := nil.
		representativeData := rawArray first.
		views do: [:v |
			v wantsFFTData ifTrue: [
				dataArray ifNil: [dataArray := fft transformDataFrom: rawArray startingAt: 1].
				v processData: dataArray
			] ifFalse: [
				v wantsRawData
					ifTrue: [v processData: rawArray]
					ifFalse: [v processData: representativeData]]].
		wantsToRecord := false.
	].
! !

!WsWorldStethoscope methodsFor: 'processing' stamp: 'yo 7/16/2008 16:19'!
processData: analyzedData 
	| factor deltas pred indices i1 v1 i2 v2 i3 v3 v |
	analyzedData isCollection ifFalse: [^ self].
	self isRangeFinderMode
		ifTrue: [#(1 2 3 4 5 6 22 23 24 25 45 46 47 68 69 70 90 91 92 113 114 115 135 136 137 159 )
				do: [:index | analyzedData at: index put: 0]].
	(passMask isNil or: [passMask size ~= (analyzedData size - 1)]) ifTrue: [self resetPassMaskFor: analyzedData].
	factor := soundInput samplingRate / fft n.
	deltas := analyzedData copyFrom: 2 to: analyzedData size.
	deltas -= analyzedData.
	pred := PredicatedArray predicates: passMask values: deltas type: #Number.
	pred atAllPut: 0.0.
	
	indices _ Array with: 1 with: 2 with: 3.
	indices sort: [:a :b | (deltas at: a) < (deltas at: b)].
	i1 _ indices at: 1. v1 _ deltas at: i1.
	i2 _ indices at: 2. v2 _ deltas at: i2.
	i3 _ indices at: 3. v3 _ deltas at: i3.
	4 to: deltas size do: [:index |
		v _ deltas at: index.
		v < v1 ifTrue: [i3 _ i2. v3 _ v2. i2 _ i1. v2 _ v1. i1 _ index. v1 _ v]
			ifFalse: [v < v2 ifTrue: [i3 _ i2. v3 _ v2. i2 _ index. v2 _ v]
					ifFalse: [v < v3 ifTrue: [i3 _ index. v3 _ v]]].
	].
	indices at: 1 put: i1; at: 2 put: i2; at: 3 put: i3.
	1 to: 3
		do: [:index | 
			| n level frequency | 
			n := (indices at: index) - 1 max: 1.
			level := analyzedData at: n.
			frequency := level < self cutOffLevel
						ifTrue: [frequency := 0.
							level := 0]
						ifFalse: [frequency := (n * factor) truncated].
			self isRangeFinderMode
				ifTrue: [frequency isZero
						ifFalse: [(sounds at: index)
								frequency: frequency + self offset
								level: level]]
				ifFalse: [(sounds at: index)
						frequency: frequency + self offset
						level: level]].
	sounds := self isSortByLevel
				ifTrue: [(sounds
						sort: [:a :b | a level > b level])]
				ifFalse: [(sounds
						sort: [:a :b | a frequency > b frequency])]! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 5/31/2007 23:26'!
rangeFindeMode: boolean
		rangeFinderMode _ boolean == true! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 5/31/2007 23:59'!
rangeFinderModeOff
	rangeFinderMode := false.
	self cutOffLevel: self defaultCutOffLevel.
	self passOver: self defaultPassOver.
	self passUnder: self defaultPassUnder! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'KR 5/1/2008 02:08'!
rangeFinderModeOn
	rangeFinderMode := true.
	self cutOffLevel: 150000.
	self passOver: 600.
	self passUnder: 4000.
	self inform: 'You should adjust ''cut off level'' to find range well.' translated! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 5/31/2007 23:27'!
rangeFinderMode: boolean
		rangeFinderMode _ boolean == true! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/11/2008 16:37'!
removeView: aMorph

	views := views copyWithout: aMorph! !

!WsWorldStethoscope methodsFor: 'private - updating' stamp: 'yo 7/14/2008 17:49'!
reset

	totalSamplesInGiga _ 0.
	totalSamples _ 0.
	recordedCount _ 0.
	wantsToRecord _ false.
	self calcNext: updateIntervalInSec and: soundInput samplingRate
! !

!WsWorldStethoscope methodsFor: 'processing' stamp: 'yo 7/14/2008 16:21'!
resetPassMaskFor: data
	| factor passUnderValue passOverValue |
	factor := soundInput samplingRate / fft n.
	passUnderValue := self passUnder - self offset / factor.
	passOverValue := self passOver - self offset / factor.

	passMask _ ByteArray new: data size - 1.
	passMask from: 1 to: passOverValue truncated put: 1.
	passMask from: passUnderValue truncated + 1 to: passMask size put: 1.
! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:04'!
setFFTSize
	| menu fftSize on |
	menu _ CustomMenu new title: 'FFT size (currently ' translated, fft n printString , ')'.
	((7 to: 10)
		collect: [:n | 2 raisedTo: n])
		do: [:r | menu add: r printString action: r].
	fftSize _ menu startUp.
	fftSize
		ifNil: [^ self].
	on _ soundInput isRecording.
	self stop.
	fft _ FFT new: fftSize.
	on
		ifTrue: [self start]! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'tetha 1/11/2004 23:05'!
setSamplingRate
	| menu rate on |
	menu _ CustomMenu new title:
		'Sampling rate (currently ' translated, soundInput samplingRate printString, ')'.
	#(11025 22050 44100) do:[:r | menu add: r printString action: r].
	rate _ menu startUp.
	rate ifNil: [^ self].
	on _ soundInput isRecording.
	self stop.
	soundInput samplingRate: rate.
	on ifTrue: [self start].

! !

!WsWorldStethoscope methodsFor: 'sort setting' stamp: 'tetha 1/11/2004 22:56'!
sortByFrequency
	sortType _ self class sortByFrequencyType! !

!WsWorldStethoscope methodsFor: 'sort setting' stamp: 'tetha 1/11/2004 22:56'!
sortByLevel
	sortType _ self class sortByLevelType! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'yo 7/16/2008 11:41'!
start
	soundInput bufferSize: fft n.
	soundInput startRecording.
	self directInputMode: directInputMode withBiasInput: biasInput.
	listening _ true! !

!WsWorldStethoscope methodsFor: 'control' stamp: 'yo 9/23/2008 16:33'!
stop
	self directInputMode: directInputMode withBiasInput: biasInput.
	soundInput stopRecording.
	listening _ false! !

!WsWorldStethoscope methodsFor: 'fileIn/out' stamp: 'tetha 1/13/2004 00:21'!
storeDataOn: aDataStream 
	| savedState |
	savedState _ self isListening.
	"soundInput stopRecording."
	self stop.
	[super storeDataOn: aDataStream]
		ensure: [savedState
				ifTrue: [self start]]! !

!WsWorldStethoscope methodsFor: 'private - updating' stamp: 'yo 7/14/2008 18:21'!
timePastTotalInGiga: newTotalSamplesInGiga and: newTotalSamples

	| past |
	past := newTotalSamplesInGiga > nextUpdateInGiga or: [newTotalSamples > nextUpdate].
	past ifTrue: [
		self calcNext: updateIntervalInSec and: soundInput samplingRate].
	^ past.
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'ka 5/31/2007 23:46'!
toggleRangeFinderMode
	self isRangeFinderMode
		ifTrue: [self rangeFinderModeOff]
		ifFalse: [self rangeFinderModeOn]! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/15/2008 15:22'!
updateInterval

	^ updateIntervalInSec
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/14/2008 17:49'!
updateInterval: aNumber

	"aNumber in seconds."
	updateIntervalInSec _ aNumber.	
	self reset.
! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'yo 7/16/2008 13:27'!
wantsFFTData

	^ directInputMode not.
! !

!WsWorldStethoscope methodsFor: 'testing' stamp: 'yo 7/16/2008 14:56'!
wantsRawData

	^ directInputMode not.
! !

!WsWorldStethoscope methodsFor: 'accessing' stamp: 'yo 7/14/2008 18:07'!
wantsToRecord: aBoolean

	wantsToRecord _ aBoolean.
! !
WsPhonePadMorph initialize!
WsWorldStethoscopeMorph initialize!
